EDIT - bug #9606

NullPointerExceptions (NPEs) in OccurrenceServicelmpl
05/04/2021 01:20 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.23

Severity: normal Found in Version:

Description

see taxon, taxonBase and name in these methods
® OccurrenceServicelmpl.countByTitle(lldentifiableEntityServiceConfigurator config)
¢ OccurrenceServicelmpl.findByTitleUuidAndTitleCache(FindOccurrencesConfigurator config)
e OccurrenceServicelmpl.findByTitleDerivedUnitDTO(FindOccurrencesConfigurator config)

Maybe more methods are affecetd

Associated revisions

Revision d9a9f2b1 - 05/04/2021 03:55 PM - Andreas Miiller
ref #9606 fix potential NPE

Revision 97fc0f95 - 05/04/2021 04:09 PM - Andreas Kohlbecker
ref #9606 fix another potential NPE

Revision 5f196d28 - 05/04/2021 10:42 PM - Andreas Miiller
ref #9606 fixing also the 3rd potential NPE

History

#1 - 05/04/2021 01:55 PM - Andreas Miiller

- Category changed from cdm to cdmlib

- Status changed from New to Feedback

- Assignee changed from Andreas Muiller to Andreas Kohlbecker
- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 5.25

Can you give a bit more inside. Any stackirace available for the NPE?
What exactly is about taxon, taxonbase and name in this methods?

#2 - 05/04/2021 01:59 PM - Andreas Kohlbecker

in these lines of countByTitle() it is obvious:

TaxonBase<?> taxonBase = taxonService.load(occurrenceConfig.getAssociatedTaxonUuid());
if (taxonBase.isInstanceOf (Taxon.class)) {
taxon = HibernateProxyHelper.deproxy (taxonBase, Taxon.class);

}
in the other methods there are things like

if (config.getAssociatedTaxonNameUuid () !=null) {
taxonName = nameService.load(config.getAssociatedTaxonNameUuid());
}
occurrences.addAll (dao.findOccurrencesUuidAndTitleCache (config.getClazz (),
config.getTitleSearchString(), config.getSignificantIdentifier(),
config.getSpecimenType (), taxon, taxonName, config.getMatchMode(), null, null,
config.getOrderHints ()));
taxonName may be null but is passed to another method, this needs to be checked

#3 - 05/04/2021 01:59 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller

#4 - 05/04/2021 03:52 PM - Andreas Miiller

- Assignee changed from Andreas Mtiller to Andreas Kohlbecker

But it is not forbidden to pass a null value, and if you follow the method that is called, there you have null values handled correctly:
createFindOccurrenceCriteria(...)

if (associatedTaxon!=null) {

else if (associatedTaxonName!=null) {

So | really do not understand what exactly the problem.
Did you get an NPE (if yes, is there a stacktrace?) or a HQL Query not working (if yes, which one) or something else (if yes what)?
#5 - 05/04/2021 03:55 PM - Andreas Miiller
Andreas Kohlbecker wrote:
in these lines of countByTitle() it is obvious:
TaxonBase<?> taxonBase = taxonService.load(occurrenceConfig.getAssociatedTaxonUuid()) ;
if (taxonBase.isInstanceOf (Taxon.class)) {

taxon = HibernateProxyHelper.deproxy (taxonBase, Taxon.class);

}

this one | fixed

#6 - 05/04/2021 03:58 PM - Andreas Kohlbecker

as said there definitely an NPE in this code line from above
taxonBase.isInstanceOf (Taxon.class)) {

The others should be checked as it is suspect, | did not dig deeper as | had no time for it. You ched it now - good, so we can forget about this part and
concentrate on the obvious NPE - seems to be fixed now !

#7 - 05/04/2021 03:58 PM - Andreas Kohlbecker
- Status changed from Feedback to In Progress

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller

#8 - 05/04/2021 04:00 PM - Andreas Miiller
- Status changed from In Progress to Resolved
- Assignee changed from Andreas Miiller to Andreas Kohlbecker

- % Done changed from 0 to 50
please review

#9 - 05/04/2021 10:43 PM - Andreas Miiller

Ahh, correct, there were also the other methods. | corrected the 3rd one now so everything should be correct now. Can we close the ticket?

#10 - 05/11/2021 05:40 PM - Andreas Kohlbecker
- Status changed from Resolved to Closed

- % Done changed from 50 to 100
yes

#11 - 05/17/2021 09:52 AM - Andreas Miiller
- Target version changed from Release 5.25 to Release 5.23
